/*--------------------------------------------------------------------------*/
/*  Copyright (C) Herbert Oppmann 2003. All Rights Reserved.                */
/*--------------------------------------------------------------------------*/
/*  Project:     MyBCP                                                      */
/*  Filename:    LZHint.h                                                   */
/*                                                                          */
/*  Description:                                                            */
/*                                                                          */
/*  LZH (de)compression internals                                           */
/*--------------------------------------------------------------------------*/

/*--< define, include >-----------------------------------------------------*/

#include <stdlib.h>	/* malloc */

#define UCHAR_MAX	255	/* max. value of input char */
#define CHAR_BIT	8	/* bits per input character */

#define MAXDICBIT	13	/* 12(-lh4-) or 13(-lh5-) */
#define DDICSIZ		(1U << MAXDICBIT)
#define MATCHBIT	8	/* bits for MAXMATCH - THRESHOLD */
#define MAXMATCH	256	/* formerly F (not more than UCHAR_MAX + 1) */
#define THRESHOLD	3	/* encode string into position and length
						   if match_length is greater than this */

#define NC			(UCHAR_MAX + MAXMATCH + 2 - THRESHOLD)
	/* "number of characters" alphabet = {0, 1, 2, ..., NC - 1} */
#define CBIT		9	/* $\lfloor \log_2 NC \rfloor + 1$ */
#define CODE_BIT	16	/* codeword length */

#define NP			(MAXDICBIT + 1)
#define NT			(CODE_BIT + 3)
#define PBIT		4	/* smallest integer such that (1U << PBIT) > NP */
#define TBIT		5	/* smallest integer such that (1U << TBIT) > NT */

#if NT > NP
#define NPT NT
#else
#define NPT NP
#endif

#define CTABLESIZE	4096

/*--< variables >-----------------------------------------------------------*/

/* common for compression and decompression, in LZHData.c */

/* static Huffman encoding */
extern ushort	left[2 * NC - 1];
extern ushort	right[2 * NC - 1];
extern uchar	c_len[NC];
extern uchar	pt_len[NPT];
/* variable number of input/output bits */
extern int		bitcount;	// number of bits in subbitbuf
extern ushort	subbitbuf;	// buffer for reading/writing variable no of bits

/*--------------------------------------------------------------------------*/
/*  Copyright (C) Herbert Oppmann 2003. All Rights Reserved.                */
/*--------------------------------------------------------------------------*/

